# -*- coding: utf-8 -*-
from setuphelpers import *

"""
[
    {
        "key": "{3544B2EE-E62F-4D11-B79C-3DDEACE94DA5}",
        "name": "Microsoft .NET Runtime - 6.0.25 (x64)",
        "version": "48.100.4028",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{3544B2EE-E62F-4D11-B79C-3DDEACE94DA5}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{AE86D888-1404-47CC-A7BB-8D86C0503E58}",
        "name": "Microsoft .NET Host FX Resolver - 6.0.25 (x64)",
        "version": "48.100.4028",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{AE86D888-1404-47CC-A7BB-8D86C0503E58}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{C7141A99-592B-4226-A4E9-B767C1D0FBAF}",
        "name": "Microsoft .NET Host - 6.0.25 (x64)",
        "version": "48.100.4028",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{C7141A99-592B-4226-A4E9-B767C1D0FBAF}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{E016F2B9-01FE-4FAA-882E-ECC43FA49751}",
        "name": "Microsoft Windows Desktop Runtime - 6.0.25 (x64)",
        "version": "48.100.4037",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{E016F2B9-01FE-4FAA-882E-ECC43FA49751}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{2deb241e-99d9-4489-ae8d-4778d470fedd}",
        "name": "Microsoft Windows Desktop Runtime - 6.0.25 (x86)",
        "version": "6.0.25.33020",
        "install_date": "",
        "install_location": "",
        "uninstall_string": '"C:\\ProgramData\\Package Cache\\{2deb241e-99d9-4489-ae8d-4778d470fedd}\\windowsdesktop-runtime-6.0.25-win-x86.exe"  /uninstall',
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{6D7737C0-9538-48ED-ACB7-688A891417C4}",
        "name": "Microsoft .NET Runtime - 6.0.25 (x86)",
        "version": "48.100.4028",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{6D7737C0-9538-48ED-ACB7-688A891417C4}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{73191C34-7ACF-493B-B92E-FE368D8F4071}",
        "name": "Microsoft .NET Host FX Resolver - 6.0.25 (x86)",
        "version": "48.100.4028",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{73191C34-7ACF-493B-B92E-FE368D8F4071}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{906F835E-F52B-47C2-A996-A769EB284880}",
        "name": "Microsoft .NET Host - 6.0.25 (x86)",
        "version": "48.100.4028",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{906F835E-F52B-47C2-A996-A769EB284880}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{AF1BA644-A730-46A9-BFE1-C1B79EBBE36D}",
        "name": "Microsoft Windows Desktop Runtime - 6.0.25 (x86)",
        "version": "48.100.4037",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{AF1BA644-A730-46A9-BFE1-C1B79EBBE36D}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{fb0500c1-f968-4621-a48b-985b52884c49}",
        "name": "Microsoft Windows Desktop Runtime - 6.0.25 (x64)",
        "version": "6.0.25.33020",
        "install_date": "",
        "install_location": "",
        "uninstall_string": '"C:\\ProgramData\\Package Cache\\{fb0500c1-f968-4621-a48b-985b52884c49}\\windowsdesktop-runtime-6.0.25-win-x64.exe"  /uninstall',
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
]


"""


def install():
    dotnet_version = control.get_software_version().split(".")[0]

    # Installing the software
    silentflags = "/install /quiet /norestart"
    if iswin64():
        install_exe_if_needed(
            glob.glob("windowsdesktop-runtime-*x64.exe")[0],
            silentflags=silentflags,
            name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*(x64)",
            min_version="",
            force=True,  # force option, since the version is not easy to check, and the installer will take care of it.
        )
    install_exe_if_needed(
        glob.glob("windowsdesktop-runtime-*x86.exe")[0],
        silentflags=silentflags,
        name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*(x86)",
        min_version="",
        force=True,  # force option, since the version is not easy to check, and the installer will take care of it.
    )

    # Clear uninstallkey to avoid the no-code audit and uninstall
    uninstallkey.clear()


def audit():
    # Declaring local variables
    audit_result = "OK"
    dotnet_version = control.get_software_version().split(".")[0]
    app_check = installed_softwares(name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*")
    audit_version = True

    # Auditing software
    if not app_check:
        print("%s is not installed" % control.package.split("-", 1)[-1].replace("-", " ").title())
        audit_result = "ERROR"
    elif audit_version:
        for to_audit in app_check:
            if r"ProgramData\Package Cache" in to_audit["uninstall_string"]:
                if Version(to_audit["version"]) < Version(control.get_software_version()):
                    print(f'{to_audit["name"]} is installed in version: {to_audit["version"]} instead of: {control.get_software_version()}.')
                    audit_result = "WARNING"
                else:
                    print("%s is installed and up-to-date." % to_audit["name"])

    return audit_result


def uninstall():
    # Declaring local variables
    dotnet_version = control.get_software_version().split(".")[0]

    for to_uninstall in installed_softwares(name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*"):
        if r"ProgramData\Package Cache" in to_uninstall["uninstall_string"]:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]) + " /norestart")
            wait_uninstallkey_absent(to_uninstall["key"])
            if isdir(to_uninstall["install_location"]):
                remove_tree(to_uninstall["install_location"])
